# Compaq ACMS for OpenVMS
ADU Reference Manual

Previous | Contents | Index

# DELETE (ADU>)

> Removes a definition from the dictionary. Use this command when you no longer need the components of an ACMS application.

## Format

## Keywords

> ### APPLICATION

> Deletes an application definition.

> ### GROUP

> Deletes a task group definition.

> ### MENU

> Deletes a menu definition.

> ### TASK

> Deletes a task definition.

## Parameter

> ### path-name

> The CDD path name of the definition to delete.

## Qualifiers

> ### /[NO]CONFIRM

> Returns information about the dictionary definition you want to delete and prompts you for confirmation before deleting the definition. The /NOCONFIRM qualifier prevents ADU from prompting you for confirmation.

> The default is /NOCONFIRM.

> ### /[NO]LOG

> The /[NO]LOG qualifier is common to several ADU commands. See Section 1.4 which describes common qualifiers.

##

### Examples

#1
    ADU> DELETE MENU MENU_ONE/LOG
    %CDU-S-MENDELETE, menu DISK1:[CDDPLUS]EXAMPLE.MENU_ONE deleted
    ADU>

> This example deletes the dictionary menu MENU_ONE in your default dictionary directory. The /LOG qualifier displays a message telling you the menu definition was successfully deleted.

#2
    ADU> DELETE APPLICATION AFP.UPDATE_EMPLOYEE

> This example deletes an application definition with the path name AFP.UPDATE_EMPLOYEE. If you omit the /LOG qualifier, ADU does not return a message indicating that the definition was deleted.

# DUMP (ADU>)

> Displays the contents of an application, menu, or task group database file. The DUMP command provides information about definitions that programmers use for cross-referencing and tracking pieces to debug an ACMS application. The DUMP command provides information in one listing, that is usually located in several different source files.

> Use this command for references to servers, workspaces, logical and given names, step names, and other components in an ACMS application.

## Format

## Keywords

> ### APPLICATION

> Displays the contents of an application database file.

> ### GROUP

> Displays the contents of a task group database file.

> ### MENU

> Displays the contents of a menu database file.

## Parameter

> ### database-file-spec

> Names the application (.ADB), task group (.TDB), or menu (.MDB) database file whose contents you want to see. File types default to .ADB for application databases, .TDB for task group databases, and .MDB for menu databases. The default device and directory are your current default device and directory.

## Qualifiers

> ### /OUTPUT [=file-spec]
> /NOOUTPUT

> Names the file to which ADU writes the output from the DUMP command. If you do not use the /OUTPUT qualifier, ADU displays the dump information. If you use /OUTPUT but do not name a file, ADU writes the dump information to a default file in your current default directory. The default file is named ADULIS.LIS.

> The /NOOUTPUT qualifier displays dump information but does not create a file.

> The default is /NOOUTPUT.

> ### /[NO]PRINT

> The /[NO]PRINT qualifier is common to several ADU commands. See Section 1.4 which describes common qualifiers.

## Notes

> The DUMP command displays summary information about menus, tasks, task groups, and applications in the database. That information includes, among other items, the file size, number of servers, and tasks in the database. To use this command, the application does not have to be active.

> The DUMP APPLICATION command lists:

> - Application user name and default directory
> - Number of application and server logicals
> - Given names for task group, server, and user
> - Maximum number of server processes
> - Maximum number of task instances
> - Creation and deletion intervals and delays
> - Task index and application server indexes
> - Application and server logical name tables
> - Task type (local or global)
> - Task status (enabled or disabled)
> - Server workspace mapping (workspaces protected or not protected)
> - Application monitoring interval
> - Transaction timeout

> The DUMP GROUP command lists:

> - Summary information about the group, including:
>   - Number of each type of workspace
>   - Number of servers and tasks
>   - Form files
>   - Request libraries
>   - Message files
> - Summary information about workspaces the group uses, including:
>   - Index number
>   - Name
>   - Size
>   - Owner
>   - Type (task or group)
>   - Initial contents (in hexadecimal and character format)

> - Summary information about servers the group uses, including:
>   - Group server name
>   - User name
>   - User name attributes
>   - Image file name, type, and index number
>   - Whether the server is reusable or is to be run down if the task is canceled
> - Summary information about tasks in the group, including:
>   - Task name, index number, input/output type
>   - Workspaces that the task references
>   - Workspace index number
>   - Block work
>   - Cancelable status of the task
>   - Workspaces
> - Summary information about each step in a task, including:
>   - Name and index
>   - Attributes
>   - Work
>   - Action
>   - Exception handler
>   - Workspaces
>   - Total workspace size
>   - Recovery
>   - Sequencing action

> The DUMP MENU command lists summary information about menus in the application's menu tree, including:

> - Application and task names
> - Number of entries per screen
> - Summary information about each entry, including:
>   - Name
>   - Number
>   - Status
>   - Type
> - Menu header
> - Menu node and request names

> You can terminate the output from the DUMP MENU, DUMP APPLICATION, and DUMP GROUP commands by pressing `[Ctrl/C]`.

## Example

    ADU> DUMP MENU ACMS$EXAMPLES:ADSAMPLE.MDB/OUTPUT=ADSAMPLE.DMP

> This command dumps the contents of the menu database file ADSAMPLE.MDB that exists in the directory ACMS$EXAMPLES into a new file named ADSAMPLE.DMP in the current default directory.

# EDIT (ADU>)

> Invokes a text editor. Use this command to correct errors in the last command line or source definition you submitted to ADU.

## Format

> EDIT

## Notes

> When you invoke the EDIT command, ADU writes the last command line or definition to a temporary file in your default directory. If you enter ADU and do not issue a command before invoking EDIT, ADU gives you an empty file.

> The file name of this temporary file is derived from your OpenVMS process identification number so each editing file has a unique name. The names of these temporary files follow the format ADU_C<PID>.COM, where <PID> is your OpenVMS process identification number. ADU spawns a subprocess and translates the system logical ADU$EDIT to invoke a text editor.

> By default, the EDIT command uses the EDT text editor. You can change the default so the EDIT command invokes the LSE text editor. For more information on changing the default editor, see Compaq ACMS for OpenVMS Writing Applications.

> To correct an error while creating or replacing a source definition, complete the definition and return to the ADU> prompt before issuing the EDIT command. You cannot issue the EDIT command from the ADUDFN> prompt.

> When you exit the editor after correcting a command line or definition, ADU invokes the ADU_C<PID>.COM file containing the corrected command or definition. If a corrected definition is free of errors, ADU creates or replaces the new definition in the dictionary as though you typed it interactively. If a corrected command line is free of errors, ADU executes the command line. ADU then deletes the ADU_C<PID>.COM file.

> If the command line or definition contains errors, ADU displays diagnostic messages and deletes the ADU_C<PID>.COM file. If you leave the editor abnormally, ADU deletes the ADU_C<PID>.COM file.

## Example

    ADU> REPLACE GROUP GROUP_ONE TSK.GDB/LOG
    %ADU-E-ERRINP, error on input file ACMS$EXC[EXAMPLE]TSK.GDB;
    -RMS-E-FNF, file not found
    %ADU-E-NOTGPREP, no task group replaced

> In this example, ADU finds an error when it processes the REPLACE command. The source file should be TSK.GDF.

> To edit the command line, type EDIT at the ADU> prompt:

    ADU> EDIT

> ADU creates the file ADU_C<PID>.COM in your default directory and places your previous command in the file. ADU spawns a subprocess, and translates the system logical ADU$EDIT to invoke the text editor.

> You can correct the command line in the editing file:

    REPLACE GROUP GROUP_ONE TSK.GDF/LOG

    *exit

> When you exit the editor, the screen displays the following message:

    SYS$32T:[MARTOCCHIO]ADU_C23A00284.COM;1 1 LINE

> The REPLACE command now compiles correctly. ADU stores the new definition in the dictionary, deletes the ADU_C23A00284.COM file, and displays a message to confirm the successful operation:

    %ADU-S-TGPREPLAC, task group DISK1:[CDDPLUS]EXAMPLE.GROUP_ONE replaced
    ADU>

# EXIT Command (ADU>)

> Ends the current ADU session and returns to the DCL prompt. Use this command when you finish using ADU and want to leave the utility.

## Format

> EXIT

## Note

> Pressing `[Ctrl/Z]` at the ADU> prompt is equivalent to using the EXIT command.

##

### Examples

#1
    ADU> EXIT
    $

> Typing EXIT at the ADU> prompt ends the ADU session and returns you to the DCL prompt.

#2
    ADU> EX
    $

> This example shows that you can exit ADU by typing the first two characters of the EXIT command.

# HELP (ADU>)

> Displays information about ADU commands and clauses. Use this command to obtain instructions on the use of ADU commands, information about ADU clauses and definitions, or error messages generated by ADU.

## Format

> HELP [/qualifier] [topic]

> Command Qualifiers | Defaults
> --- | ---
> /[NO]PROMPT | /PROMPT

## Parameter

> ### topic

> Names one or more topics about which you want information.

## Qualifiers

> ### /[NO]PROMPT

> Prompts you for topics about which you want information. Always type the /PROMPT qualifier immediately after the HELP keyword.

> The /NOPROMPT qualifier keeps ADU from prompting you for topics. After ADU displays the information you requested, it returns directly to the ADU> prompt without displaying the Topic? prompt. Always type the /NOPROMPT qualifier immediately after the HELP keyword.

> The default is /PROMPT.

## Notes

> ADU HELP follows the same conventions as the OpenVMS HELP facility.

> Press `[Return]` at the HELP prompt to move to a higher or more general level in the HELP hierarchy.

> The HELP text is in the file SYS$HELP:ACMSADU.HLB. You can modify it using the standard OpenVMS facilities.

## Example

    ADU> HELP
    Information available:

      %INCLUDE   &          @          APPLICATION           ATTACH     BUILD
      Command_Recall        COPY       CREATE     DELETE     DUMP       EDIT
      Errors     EXIT       GROUP      HELP       KEYPAD     LIST       LSE
      MENU       MODIFY     REPLACE    SAVE       SET        SHOW       SPAWN
      STEPS      TASK

    Topic?

> In this example, the HELP command displays the ADU help that is available. Type one of these topics at the Topic? prompt to get the information you need.

    Topic? SHOW

    SHOW

       Specifies that you wish to choose one of the SHOW operations.

       Format:

           SHOW keyword

       Valid keywords are DEFAULT, LOG, and VERSION.

      Additional information available:

      DEFAULT    LOG        VERSION

    SHOW Subtopic?

> This command displays HELP information about the SHOW command and displays a prompt at which you can get information about the three SHOW command keywords.

# LINK (ADU>)

Converts object definitions from OpenVMS files into binary database files that ACMS uses at run time. This LINK command is executed from within ADU. Do not confuse it with the DCL LINK command.

## Format

## Keywords

> ### APPLICATION

> Builds an application database.

> ### GROUP

> Builds a task group database.

> ### MENU

> Builds a menu database.

## Parameters

> ### compile-result-file-spec

> The file that contains the compilation results of the object to be linked. The file name component of the file specification must be supplied. If the file specification is not fully qualified, the following defaults are used: current device; current directory; and a file type of .ABJ for applications, .GBJ for task groups, and .MBJ for menus. When used with the LINK GROUP /STDL command, path-name is the task group name; when used with the LINK APPLICATION /STDL command, path-name is the application name.

> ### database-file-spec

> The file specification for the database file that the LINK command creates. This output file is a database file that ACMS uses at run time. The LINK command can create an application, task group, or menu database file.

> If you do not name a database file when you link an application, task group, or menu definition, ADU uses the file named in the DEFAULT APPLICATION FILE, DEFAULT GROUP FILE, or DEFAULT MENU FILE clause in the application, task group, or menu definition. If you do not use the DEFAULT APPLICATION FILE, DEFAULT GROUP FILE, or DEFAULT MENU FILE clause, ADU derives the database file specification from the given name of the application, task group, or menu. ACMS uses the full given name, including dollar signs ($) and underscores (_), for the default database file name.

> The default file type for an application database file is .ADB, for a menu database file it is .MDB, and for a task group database file it is .TDB.

> The default directory is your current default directory. The default device is SYS$DISK, which must translate to a device name.

## Qualifiers

> ### /[NO]DEBUG

> Creates symbols for the ACMS Task Debugger. These symbols are appended to the task group database (.TDB) file. Use this qualifier to examine workspaces in the ACMS debugger or deposit workspaces into the debugger. You can use this qualifier only when linking a task group.

> The /NODEBUG qualifier makes the contents of workspaces unavailable during a debugging session.

> The default is /NODEBUG.

> ### /LIST [=list-file-spec]/NOLIST

> The /LIST and /NOLIST qualifiers are common to several ADU commands. See Section 1.4, which describes common qualifiers.

> ### /[NO]LOG

> The /[NO]LOG qualifier is common to several ADU commands. See Section 1.4 which describes common qualifiers.

> ### /OBJECT=(file-spec [,...] ) /NOOBJECT

> Controls whether object modules are searched for global symbol resolution during link group processing.

> The default is /NOOBJECT.

> ### /[NO]PRINT

> The /[NO]PRINT qualifier is common to several ADU commands. See Section 1.4, which describes common qualifiers.

> ### /REFERENCED_OBJECT_DEFAULT

> The default file specification used to find the referenced compilation results. This qualifier is used in the following cases:
> - When linking a task group, ADU uses this qualifier to find the compilation results for all of the tasks that are referenced by the task group being linked.
> - When linking a menu, ADU uses this qualifier to find the compilation results for all of the menus that are referenced by the menu being linked.

> You cannot specify the file name with this qualifier.

> ### /[NO]STDL

> Translates an ACMS application's record definitions extracted from the CDD along with the .OBJ files for task headers and task group and task definitions to an STDL task group specification, data type definitions, STDL record definitions, and task group headers with records as arguments. The translation takes place in two processing stages: group_task translation, which is initiated by the LINK GROUP /STDL command, and application_group translation, which is initiated by the LINK APPLICATION /STDL command. You use the STDL output file to create the client interface that enables Windows NT clients to access ACMS applications.

> ### /[NO]SYSLIB

> The /[NO]SYSLIB qualifier controls whether or not to search the default system libraries SYS$LIBRARY:IMAGELIB.OLB and SYS$LIBRARY:STARLET.OLB to resolve global symbols during link group processing. The default is /SYSLIB. The system libraries are not searched if you use the /NOSYSLIB qualifier. If you use both the /NOSYSLIB and /SYSSHR qualifiers, the /SYSSHR qualifier is ignored.

> ### /[NO]SYSSHR

> The /[NO]SYSSHR qualifier controls whether or not to search SYS$LIBRARY:IMAGELIB.OLB to resolve global symbols during link group processing. The default is /SYSSHR.

> ### /USERLIBRARY=(file-spec [,...] ) /NOUSERLIBRARY

> The /USERLIBRARY and /NOUSERLIBRARY qualifiers control whether or not to search user-specified object libraries and shared image libraries to resolve global symbols during link group processing. The default is /NOUSERLIBRARY. If you use the /NOSYSLIB or /NOSYSSHR qualifier, you can specify the default system libraries SYS$LIBRARY:IMAGELIB.OLB or SYS$LIBRARY:STARLET.OLB with the /USERLIBRARY qualifier.

## Notes

> ADU determines where to find referenced objects using several pieces of information. The defaults are as follows:

> - The device defaults to the current device.
> - The directory defaults to the current directory.
> - The file extension defaults to .ABJ for application result files, .GBJ for task group result files, and .MBJ for menu result files.

> Any of these components of the file specification can be overridden by supplying them in the /REFERENCED_OBJECT_ DEFAULT qualifier. ADU uses the name of the entity that is being pulled in by the link as the file name. ADU produces a procedure server object module for each procedure server named in the task group definition.

> ADU derives the file name from the unique name of the server (from the SERVER IS clause).

> If you do not use the DEFAULT OBJECT FILE subclause, ADU derives the name of the server object file from the unique name of the server. ADU uses the full given name, included dollar signs ($) and underscores (_). The file is written to the same directory as the task group database file with a file type of .OBJ.

##

### Examples

#1
    ADU>  LINK GROUP employee_group

> This command builds a task group database using the task group result file from a previous COMPILE command. The task group result file is in the current directory with the name of employee_group.GBJ. The output file from the LINK command will have the name employee_group.TDB.

#2
    ADU>  LINK APPL employee_appl

> This command builds an application database using the application result file from a previous COMPILE command. The application result file is in the current directory with the name of employee_appl.ABJ. The output file from the LINK command will have the name employee_appl.ADB.

#3
    ADU>  LINK MENU employee_menu

> This command builds an menu database using the menu result file from a previous COMPILE command. The menu result file is in the current directory with the name of employee_menu.MBJ. The output file from the LINK command will have the name employee_menu.MDB.

#4
    ADU>  LINK GROUP group_fields/STDL

> This command causes ADU to output task and record information that is used for the final translation to STDL. The output file will have the name group_fields.WDB.

#5
    ADU>  LINK APPL employee_appl/STDL

> This command causes ADU to output STDL code using the intermediate format group file that was created during the ACMSADU COMPILE GROUP compilation. The output file will have the name employee_appl.STDL.

Previous | Next | Contents | Index